// ************************************************************************************************ 
//    Absolute Beginner Projekt 04_1
//
//	Textanzeige auf einem LCD und Einlesen von 4 Taster
//
// Die Taster werden von PortB6 ber Widerstnde parallel auf die Datenleitungen des LCD gelegt.
// Dadurch hat man bei Verwendung von nur einem weiteren Pin vier zustzliche Informationen eingelesen
// ************************************************************************************************ 
// Copyright keins
// Version 
/*
* Chip type           : ATMEGA 88
* Clock frequency     : Internal clock 1 Mhz (The device is shipped with this option selected.)
* Fuse Bits einfach auf Auslieferungszustand lassen!

Ein- und Ausgnge
PORT B 0 (14) = Anschluss 11 am LCD = DB4 + Taster 1
PORT B 1 (15) = Anschluss 12 am LCD = DB5 + Taster 2
PORT B 2 (16) = Anschluss 13 am LCD = DB6 + Taster 3
PORT B 3 (17) = Anschluss 14 am LCD = DB7 + Taster 4
PORT B 4 (18) = Anschluss  4 am LCD = RS
PORT B 5 (19) = Anschluss  6 am LCD = E Enable
PORT B 6 ( 9) = Common Taster
PORT B 7 (10) = 

PORT C 0 (23) = Mittelabgriff 1KOhm Poti, die anderen Enden hngen an VCC und GND
PORT C 1 (24) = 
PORT C 2 (25) = 
PORT C 3 (26) = 
PORT C 4 (27) = 	
PORT C 5 (28) = 

PORT D 0 ( 2) = 
PORT D 1 ( 3) = 
PORT D 2 ( 4) =  
PORT D 3 ( 5) =  
PORT D 4 ( 6) = 
PORT D 5 (11) = 
PORT D 6 (12) = 
PORT D 7 (13) = 
*/


// Main.c
// 

// ************************************************************************************************ 
// Include Dateien laden
// ************************************************************************************************ 
#include	<avr\io.h>	//AVR Register und Konstantendefinitionen
#include	<avr\interrupt.h> //AVR Interrupt Vektoren
#include	<stdlib.h>
#include	<inttypes.h>
#include "lcd-routines.h"
#include <util/delay.h>




// ************************************************************************************************ 
// Globale Variablen 
// sind auch in allen Unterroutinen verwendbar.
// ************************************************************************************************ 




              
// ************************************************************************************************ 
//                       Initialisierung          
// ************************************************************************************************ 
void initial(void)
{    



// **** Einrichten von Ein- und Ausgngen *************** 
DDRD = 0xff;      	// PortD Ausgnge 
DDRC = 0x00;      	// PortC Eingnge 


DDRB &=~_BV(6);



}
// ************************************************************************************************ 



// *******Abfrage Taster  **************************************** 

// Durch die Bettigung der Taster wird das Signal an PB6 auf 0 gezogen

// ******************************************************************* 	

unsigned char pushbutton(uint8_t chanel)
{


uint8_t hilf=0;

PORTB |= _BV(6);	// Pull up Widerstand Pin 6 einschalten
			// muss bei jedem Aufruf geschehen, da die
			// LCD Routinen auf den ganzen PortB schreiben

PORTB |= _BV(0);
PORTB |= _BV(1);
PORTB |= _BV(2);
PORTB |= _BV(3);

PORTB &=~_BV(chanel);	// Gegenstck zum abzufragenden Taster auf 0 setzen

_delay_us(42);		// Wartezeit bis der Signalwechsel auch am Pin erkannt wird

if ( !(PINB & (1<<6)) ) hilf=0; else hilf=1; // wenn PB6 =0 dann Taser bettigt

return(hilf);
}








// ************************************************************************************************ 
// Hauptprogramm
// ************************************************************************************************ 




int main(void)
{


 // ******** Initialisierung ***********************************************************************

lcd_init(); // Initialisierung des LCD
initial();	// Initialisierung Ports etc.


// ******** Hauptschleife ************************************************************************* 	
    
  while(1)
  {

uint8_t taster0=0;
uint8_t taster1=0;
uint8_t taster2=0;
uint8_t taster3=0;

// *Taster Abfrage ****************************************************************************** 

taster0=pushbutton(0);	// Abfrage erster Taster
taster1=pushbutton(1);	// Abfrage zweiter Taster
taster2=pushbutton(2);	// Abfrage dritter Taster
taster3=pushbutton(3);	// Abfrage vierter Taster




// *LCD Anzeige ****************************************************************************** 

if (taster0)   lcd_data( 'A' ); else lcd_data( 'a' ); 
if (taster1)   lcd_data( 'B' ); else lcd_data( 'b' ); 
if (taster2)   lcd_data( 'C' ); else lcd_data( 'c' ); 
if (taster3)   lcd_data( 'D' ); else lcd_data( 'd' ); 

lcd_setcursor( 0, 1 );



// ************************************************************************************************ 




  }
 
  return 0;
}
